package LLI::Search;

# A search request object
#
# $Id: Search.pm,v 1.1 2003/03/24 01:05:11 mankins Exp $

my $VERSION = 1.00;

use strict;

sub new 
  {
    my $proto = shift;
    my $class = ref($proto) || $proto;

    my ($params) = @_;

    my ($return_node,$expiration,$owner) = (
					    $params->{'node_name'},
					    $params->{'expiration'},
					    $params->{'owner'},
					   );

    &LLI::debug("search started with",$return_node,$expiration,$owner);

    return undef unless ( (defined ($return_node)) && (defined ($expiration)) );

    my $self = {};
    bless ($self, $class);

    $self->expiration($expiration);
    $self->owner($owner);
    $self->node_name($return_node);

    $self->clear_criteria();

    return $self;
  }

sub expiration
  {
    my $self = shift;

    my ($set) = @_;

    if ($set)
      {
	# We want to set to this value.
	return $self->{'expiration'} = $set;
      }
    else
      {
	return $self->{'expiration'};
      }
  }

sub owner
  {
    my $self = shift;

    my ($set) = @_;

    if ($set)
      {
	# We want to set to this value.
	return $self->{'owner'} = $set;
      }
    else
      {
	return $self->{'owner'};
      }
  }

sub node_name
  {
    my $self = shift;

    my ($set) = @_;

    if ($set)
      {
	# We want to this value.
	return $self->{'node_name'} = $set;
      }
    else
      {
	return $self->{'node_name'};
      }
  }

sub set_criteria
  {
    my $self = shift;

    my ($criteria) = @_;

    return unless $criteria;

    my ($lat,$lon,$alt,$radius,$type) = (
					 $criteria->{'lat'},
					 $criteria->{'lon'},
					 $criteria->{'alt'},
					 $criteria->{'radius'},
					 $criteria->{'alt'},
					 $criteria->{'type'},
					);

    # set our current critera (does not clear first!)
    foreach my $key (keys %{ $criteria })
      {
	$self->{"criteria"}->{$key} = $criteria->{$key};
      }
    
    return $self->{'criteria'};
  }

sub get_criteria
  {
    my $self = shift;

    return $self->{'criteria'};
  }

sub clear_criteria
  {
    my $self = shift;

    return $self->{'criteria'} = {};
  }

1;
