package PubsubConstants;

require Exporter;

our @ISA = qw(Exporter);
our @EXPORT = qw(SUBSCRIPTION_OPEN SUBSCRIPTION_AUTHORIZE SUBSCRIPTION_WHITELIST 
		 PUBLISH_OPEN PUBLISH_SUBSCRIBERS PUBLISH_PUBLISHERS
		 OUTCAST NONE PENDING SUBSCRIBER PUBLISHER OWNER
		 ERROR_NOT_AUTHORIZED ERROR_NOT_FOUND ERROR_NOT_ALLOWED ERROR_CONFLICT ERROR_NOT_PERSISTENT ERROR_INTERNAL
		 %AFFILIATION %ERROR
                );
our $VERSION = 0.01;

use vars qw(%AFFILIATION %ERROR);

# Setup constants

use constant SUBSCRIPTION_OPEN       => 0;
use constant SUBSCRIPTION_AUTHORIZE  => 1;
use constant SUBSCRIPTION_WHITELIST  => 2;

use constant PUBLISH_OPEN        => 0;
use constant PUBLISH_SUBSCRIBERS => 1;
use constant PUBLISH_PUBLISHERS  => 2;

use constant OUTCAST     => -1;
use constant NONE        => 0;
use constant PENDING     => 1;
use constant SUBSCRIBER  => 2;
use constant PUBLISHER   => 3;
use constant OWNER       => 4;

use constant ERROR_NOT_AUTHORIZED    => 401;
use constant ERROR_NOT_FOUND         => 404;
use constant ERROR_NOT_ALLOWED       => 405;
use constant ERROR_CONFLICT          => 409;
use constant ERROR_NOT_PERSISTENT    => 410;
use constant ERROR_INTERNAL          => 500;

%AFFILIATION = (
    OUTCAST()    => "outcast",
    NONE()       => "none",
    PENDING()    => "pending",
    SUBSCRIBER() => "subscriber",
    PUBLISHER()  => "publisher",
    OWNER()      => "owner"
);

%ERROR = (
    ERROR_NOT_AUTHORIZED()  => "Not Authorized",
    ERROR_NOT_FOUND()       => "Node Not Found",
    ERROR_NOT_ALLOWED()     => "Not Allowed",
    ERROR_CONFLICT()        => "Conflict",
    ERROR_NOT_PERSISTENT()  => "Node Not Persistent",
    ERROR_INTERNAL()        => "Internal Error",
);

$Net::Jabber::Query::NAMESPACES{'http://jabber.org/protocol/pubsub'}->{Create}->{XPath}->{Type}  = 'node';
$Net::Jabber::Query::NAMESPACES{'http://jabber.org/protocol/pubsub'}->{Create}->{XPath}->{Path}  = 'create';
$Net::Jabber::Query::NAMESPACES{'http://jabber.org/protocol/pubsub'}->{Create}->{XPath}->{Child} = ['Query', '__netjabber__:iq:pubsub:create'];
$Net::Jabber::Query::NAMESPACES{'http://jabber.org/protocol/pubsub'}->{Create}->{XPath}->{Calls} = ['Add'];

$Net::Jabber::Query::NAMESPACES{'http://jabber.org/protocol/pubsub'}->{Entity}->{XPath}->{Type}  = 'node';
$Net::Jabber::Query::NAMESPACES{'http://jabber.org/protocol/pubsub'}->{Entity}->{XPath}->{Path}  = 'entity';
$Net::Jabber::Query::NAMESPACES{'http://jabber.org/protocol/pubsub'}->{Entity}->{XPath}->{Child} = ['Query', '__netjabber__:iq:pubsub:entity'];
$Net::Jabber::Query::NAMESPACES{'http://jabber.org/protocol/pubsub'}->{Entity}->{XPath}->{Calls} = ['Add'];

$Net::Jabber::Query::NAMESPACES{'http://jabber.org/protocol/pubsub'}->{Entities}->{XPath}->{Type}  = 'node';
$Net::Jabber::Query::NAMESPACES{'http://jabber.org/protocol/pubsub'}->{Entities}->{XPath}->{Path}  = 'entities';
$Net::Jabber::Query::NAMESPACES{'http://jabber.org/protocol/pubsub'}->{Entities}->{XPath}->{Child} = ['Query', '__netjabber__:iq:pubsub:entities'];
$Net::Jabber::Query::NAMESPACES{'http://jabber.org/protocol/pubsub'}->{Entities}->{XPath}->{Calls} = ['Add'];

$Net::Jabber::Query::NAMESPACES{'http://jabber.org/protocol/pubsub'}->{Pubsub}->{XPath}->{Type}  = 'master';

$Net::Jabber::Query::NAMESPACES{'__netjabber__:iq:pubsub:create'}->{Node}->{XPath}->{Path} = '@node';

$Net::Jabber::Query::NAMESPACES{'__netjabber__:iq:pubsub:create'}->{Create}->{XPath}->{Type}  = 'master';

$Net::Jabber::Query::NAMESPACES{'__netjabber__:iq:pubsub:entities'}->{Node}->{XPath}->{Path}  = '@node';

$Net::Jabber::Query::NAMESPACES{'__netjabber__:iq:pubsub:entities'}->{Entity}->{XPath}->{Type}  = 'children';
$Net::Jabber::Query::NAMESPACES{'__netjabber__:iq:pubsub:entities'}->{Entity}->{XPath}->{Path}  = 'entity';

$Net::Jabber::Query::NAMESPACES{'__netjabber__:iq:pubsub:entities'}->{Entity}->{XPath}->{Child}  = ['Query', '__netjabber__:iq:pubsub:entity'];
$Net::Jabber::Query::NAMESPACES{'__netjabber__:iq:pubsub:entities'}->{Entity}->{XPath}->{Calls}  = ['Add'];

$Net::Jabber::Query::NAMESPACES{'__netjabber__:iq:pubsub:entity'}->{JID}->{XPath}->{Path} = '@jid';
$Net::Jabber::Query::NAMESPACES{'__netjabber__:iq:pubsub:entity'}->{Affiliation}->{XPath}->{Path} = '@affiliation';
$Net::Jabber::Query::NAMESPACES{'__netjabber__:iq:pubsub:entity'}->{Subscription}->{XPath}->{Path} = '@subscription';

$Net::Jabber::Query::NAMESPACES{'__netjabber__:iq:pubsub:entity'}->{Entity}->{XPath}->{Type}  = 'master';

$Net::Jabber::X::NAMESPACES{'http://jabber.org/protocol/pubsub#event'}->{Items}->{XPath}->{Type} = 'node';
$Net::Jabber::X::NAMESPACES{'http://jabber.org/protocol/pubsub#event'}->{Items}->{XPath}->{Path} = 'items';
$Net::Jabber::X::NAMESPACES{'http://jabber.org/protocol/pubsub#event'}->{Items}->{XPath}->{Child} = ['X', '__netjabber__:x:pubsub:items'];
$Net::Jabber::X::NAMESPACES{'http://jabber.org/protocol/pubsub#event'}->{Items}->{XPath}->{Calls} = ['Add'];

$Net::Jabber::X::NAMESPACES{'__netjabber__:x:pubsub:items'}->{Node}->{XPath}->{Path} = '@node';

$Net::Jabber::X::NAMESPACES{'__netjabber__:x:pubsub:items'}->{Item}->{XPath}->{Type} = 'children';
$Net::Jabber::X::NAMESPACES{'__netjabber__:x:pubsub:items'}->{Item}->{XPath}->{Path} = 'item';
$Net::Jabber::X::NAMESPACES{'__netjabber__:x:pubsub:items'}->{Item}->{XPath}->{Child} = ['X', '__netjabber__:x:pubsub:items:item'];
$Net::Jabber::X::NAMESPACES{'__netjabber__:x:pubsub:items'}->{Item}->{XPath}->{Calls} = ['Add'];

$Net::Jabber::X::NAMESPACES{'__netjabber__:x:pubsub:items:item'}->{Id}->{XPath}->{Path} = '@id';

$Net::Jabber::Query::NAMESPACES{'http://jabber.org/protocol/disco#items'}->{Item}->{XPath}->{Type} = 'children';
$Net::Jabber::Query::NAMESPACES{'http://jabber.org/protocol/disco#items'}->{Item}->{XPath}->{Path} = 'item';

$Net::Jabber::Query::NAMESPACES{'http://jabber.org/protocol/disco#items'}->{Item}->{XPath}->{Child} = ['Query', '__netjabber__:iq:query:item'];
$Net::Jabber::Query::NAMESPACES{'http://jabber.org/protocol/disco#items'}->{Item}->{XPath}->{Calls} = ['Add'];

$Net::Jabber::Query::NAMESPACES{'__netjabber__:iq:query:item'}->{JID}->{XPath}->{Path} = '@jid';
$Net::Jabber::Query::NAMESPACES{'__netjabber__:iq:query:item'}->{Node}->{XPath}->{Path} = '@node';
$Net::Jabber::Query::NAMESPACES{'__netjabber__:iq:query:item'}->{Name}->{XPath}->{Path} = '@name';

1;
